var Contact = (function()
{
	return {

		submit: function()
		{
			var $nameInput = $('#name');
			var $emailInput = $('#email');
			var $messageInput = $('#message');
			var $submitBtn = $('form .btn');
			var url = $('form').attr('action');

			var $inputs = $('form :input');
			var params = {};

			$inputs.each(function()
			{
				params[this.id] = $(this).val();
			});

			$submitBtn.text("Submitting...");

			// Clear previous errors
			$('.alert').remove();
			$('.input-error-text').remove();
			$('.input-error').removeClass('input-error');

			$.ajax({
				type: 'POST',
				url: url,
				data: params,
				dataType: 'json',
				timeout: 1000 * 10,

				success: function(data)
				{
					// Errors
					if(!data.success)
					{
						Contact.showErrors(data);
					}
					// Success
					else
					{
						// Success message
						$('form').prepend('<div class="alert alert-success"><i class="fa fa-check"></i> ' + data.message + '</div>');

						// Clear form data
						$nameInput.val('');
						$emailInput.val('');
						$messageInput.val('');

						// Reset form
						$submitBtn.text('Send Message');
						$(window).scrollTop(0);
					}
				},

				error: function(request, status, err)
				{
					var data = null;
					if(request != null && request.responseText != null)
					{
						data = JSON.parse(request.responseText)
					}

					Contact.showErrors(data);
				}

			});

		},


		showErrors: function(response)
		{
			// General error
			var message = 'We were unable to submit your message at this time. Make sure that you have an internet connection or email us directly at support@jigsawdaily.com.';
			if(response != null && response.message != undefined)
			{
				message = response.message;
			}

			// Specific errors
			if(response != null && response.errors != undefined)
			{
				for (var key in response.errors)
				{
					$element = $('#' + key);
					$element.addClass('input-error');
					$element.before('<p class="input-error-text">' + response.errors[key] + '</p>');
				}
			}

			$('form .btn').text('Send Message');
			$('form').prepend('<div class="alert alert-error"><i class="fa fa-exclamation-circle"></i> ' + message + '</div>');
			$(window).scrollTop(0);
		}


	};

})();