var Page = (function()
{
	return {

		preload: function(content, pageHeight)
		{
			// Remove any old content
			$('#old-page').remove();

			var $oldPage = $('#page');
			var $newPage = $('<div id="page" class="page-loading"></div>');

			$oldPage.attr('id', 'old-page');

			$('body').append($newPage);
			$newPage.html(content);

			if(pageHeight > 0)
			{
				$newPage.height(pageHeight);
			}
			else
			{
				$newPage.css('height', 'auto');
			}
		},


		show: function(scrollY)
		{
			var $oldPage = $('#old-page');
			var $newPage = $('#page');

			$oldPage.remove();
			$newPage.removeClass('page-loading');
			$(window).scrollTop(scrollY);
		},


		updatePackDownloadProgress: function(packId, progressPercent)
		{
			$pack = $('#pack-' + packId);
			$pack.find('.redownload').remove();

			// Downloading
			if(progressPercent < 1)
			{
				$pack.addClass('deleted');

				if(!$pack.find('.downloading').length)
				{
					$pack.find('a').attr('href', 'as:downloading');
					$pack.append('<div class="downloading" onclick="AS3.call(\'downloading\')"><i class="fa fa-refresh"></i><br>DOWNLOADING</div>');
				}

				if(!$pack.find('.downloading .bar').length)
				{
					$pack.find('.downloading').append('<div class="bar"></div>');
				}

				if(progressPercent > 0)
				{
					if(!$pack.find('.downloading .bar .fill').length)
					{
						$pack.find('.downloading .bar').append('<div class="fill"></div>');
					}

					$pack.find('.fill').width((progressPercent * 100) + '%');
				}
			}
			// Download complete
			else
			{
				$pack.removeClass('deleted');
				$pack.find('.downloading').remove();
				$pack.find('a').attr('href', 'as:url@pack/' + packId);
			}

		},


		refreshImage: function(selector)
		{
			var url = $(selector).attr('src');

			$(selector).attr('src', '');
			$(selector).attr('src', url);
		}

	}


})();